﻿@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@using Portal.Models.Delivery.PRApproval;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.MVC;

@Html.Common().DevExpress().GridView(
setting =>    {

    setting.Name = "GridPRApporval";
    setting.Width = Unit.Percentage(98);
    //setting.Height = Unit.Percentage(100);
    setting.Settings.ShowFilterRow = true;
    setting.Settings.ShowFilterRowMenu = true;
    setting.Settings.ShowColumnHeaders = true;
    setting.KeyFieldName = "PR_NO";
    
    setting.CallbackRouteValues = new { Controller = "D31104", Action = "PartialDatas" };
    setting.ClientSideEvents.BeginCallback = "OnBeginCallbackGrid";
    setting.ClientSideEvents.EndCallback = "OnEndCallbackGrid";
    setting.ClientSideEvents.Init = "gridPRApproval_Init";
    setting.SettingsBehavior.AllowSelectSingleRowOnly = false;
    setting.SettingsBehavior.AllowSelectByRowClick = true;
    
    setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Visible;
    setting.Settings.VerticalScrollBarMode = ScrollBarMode.Hidden;
    setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
    setting.Styles.Header.VerticalAlign = VerticalAlign.Middle;

    
    
    setting.SettingsPager.FirstPageButton.Visible = true;
    setting.SettingsPager.LastPageButton.Visible = true;
    setting.SettingsPager.ShowNumericButtons = true;
    //setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Hidden;
    setting.SettingsPager.Position = PagerPosition.Bottom;
    setting.SettingsPager.PageSizeItemSettings.Visible = true;
    setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
    setting.SettingsPager.PageSizeItemSettings.Caption = "Page size";
    
    setting.CommandColumn.Visible = true;
    setting.CommandColumn.Width = Unit.Pixel(40);
    setting.CommandColumn.ClearFilterButton.Visible = true;
    setting.CommandColumn.ShowSelectCheckbox = true;

    setting.ClientSideEvents.SelectionChanged = "GridPRApporval_SelectionChange";

    setting.CustomJSProperties = (s, e) =>
    {
        MVCxGridView grid = (MVCxGridView)s;
        //int startIndex = grid.PageIndex * grid.SettingsPager.PageSize;
        //int end = Math.Min(grid.VisibleRowCount, startIndex + grid.SettingsPager.PageSize);
        int startIndex = 0;
        int endIndex = Model.GetModel<List<PRApprovalData>>().Count;
        //--=== List object
        //object[] PROD_MONTH = new object[endIndex - startIndex];
        object[] PR_NO = new object[endIndex - startIndex];
        //object[] LP_CD = new object[endIndex - startIndex];
        object[] isSelected = new object[endIndex - startIndex];


        for (int n = startIndex; n < endIndex; n++)
        {
            
            //PROD_MONTH[n - startIndex] = grid.GetRowValues(n, "PROD_MONTH");
            //PR_NO[n - startIndex] = grid.GetRowValues(n, "PR_NO");
            //LP_CD[n - startIndex] = grid.GetRowValues(n, "LP_CD");
            PR_NO[n - startIndex] = grid.GetRowValues(n, "PR_NO");
            isSelected[n - startIndex] = grid.Selection.IsRowSelected(n);

        }
        //e.Properties["cpPROD_MONTH"] = PROD_MONTH;
        e.Properties["cpPR_NO"] = PR_NO;
        //e.Properties["cpLP_CD"] = LP_CD;
        
        e.Properties["cpFocusedRowIndex"] = grid.FocusedRowIndex;
        e.Properties["cpKeyfield"] = grid.KeyFieldName;
        e.Properties["cpIsRowSelected"] = isSelected;
        e.Properties["cpVisibleRow"] = grid.VisibleRowCount;

        grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
        grid.JSProperties["cpStartIndex"] = startIndex;
        grid.JSProperties["cpEndIndex"] = endIndex;
    };

    setting.CommandColumn.SetHeaderTemplateContent(
    c =>
    {
        Html.DevExpress().CheckBox(
                chckBox =>
                {
                    chckBox.Name = "SelectAllCheckBox";
                    //chckBox.Properties.ClientSideEvents.CheckedChanged = "function(s, e){ GridPRApporval.SelectAllRowsOnPage(chkAllRecord.GetChecked());}";
                    chckBox.Properties.ClientSideEvents.CheckedChanged = string.Format("function(s, e) {{ if(s.GetChecked()) {0}.SelectRows(); else {0}.UnselectRows(); }}", setting.Name);
                    chckBox.Checked = c.Grid.Selection.Count == c.Grid.VisibleRowCount;
                    
                }
            ).Render();
    });

    setting.Columns.Add(
    pic =>
    {
        pic.Name = "PROD_MONTH";
        pic.FieldName = "PROD_MONTH";
        pic.Caption = "Production <br />Month";
        pic.Width = Unit.Pixel(80);
        //pic.HeaderStyle.Font.Bold = true;
        pic.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        pic.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        pic.CellStyle.VerticalAlign = VerticalAlign.Middle;
        pic.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(
        column =>
        {
            column.Name = "PR_NO";
            column.FieldName = "PR_NO";
            column.Caption = "PR Number";
            column.Width = Unit.Pixel(100);
            //column.HeaderStyle.Font.Bold = true;
            column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            column.SetDataItemTemplateContent(
                content =>
                {
                    GridViewDataItemTemplateContainer c = (GridViewDataItemTemplateContainer)content;
                    Html.DevExpress().HyperLink(
                        link =>
                        {
                            link.Name = "lnkPR_NO" + content.VisibleIndex;
                            link.NavigateUrl = "javascript:void(0)";
                            link.Properties.Text = content.Text;
                            link.ClientVisible = true;
                            link.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OnPRClick('{0}'); }}", (content as GridViewDataItemTemplateContainer).Text);

                        }).Render();
                });
        });


    //-------[ PR STATUS BEGIN ]--------
    setting.Columns.AddBand(
    columnBand =>
    {
        columnBand.Caption = "Status";
        columnBand.Columns.Add(
            shpr =>
            {
                shpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                shpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                shpr.Caption = "SH";
                shpr.Name = "SH_APPROVED_DT";
                shpr.FieldName = "SH_APPROVED_DT";
                shpr.Width = Unit.Pixel(50);
                shpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;

                shpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                shpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;

                shpr.SetDataItemTemplateContent(
                    dtshpr =>
                    {

                        Html.DevExpress().Image(
                            img =>
                            {
                                img.Properties.ImageAlign = ImageAlign.Middle;
                                img.ImageUrl = "~/Content/Images/" + dtshpr.Text + ".png"; //"~/Content/Images/Green.png";

                            }).Render();
                    });


            }
            );


        columnBand.Columns.Add(
            dphpr =>
            {
                dphpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                dphpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                dphpr.Caption = "DpH";
                dphpr.Name = "DPH_APPROVED_DT";
                dphpr.FieldName = "DPH_APPROVED_DT";
                dphpr.Width = Unit.Pixel(50);
                dphpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                dphpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                dphpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;

                dphpr.SetDataItemTemplateContent(
                    dtdphpr =>
                    {
                        Html.DevExpress().Image(
                            img =>
                            {
                                img.Properties.ImageAlign = ImageAlign.Middle;
                                img.ImageUrl = "~/Content/Images/" + dtdphpr.Text + ".png"; ;
                            }).Render();
                    });


            }
            );
        columnBand.Columns.Add(
            dhpr =>
            {
                dhpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                dhpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                dhpr.Caption = "DH";
                dhpr.Name = "DH_APPROVED_DT";
                dhpr.FieldName = "DH_APPROVED_DT";
                dhpr.Width = Unit.Pixel(50);
                dhpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                dhpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                dhpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;

                dhpr.SetDataItemTemplateContent(
                    dtdhpr =>
                    {
                        Html.DevExpress().Image(
                            img =>
                            {
                                img.Properties.ImageAlign = ImageAlign.Middle;
                                img.ImageUrl = "~/Content/Images/" + dtdhpr.Text + ".png";
                            }).Render();
                    });


            }
            );


    }
    );

    setting.Columns.Add(
        pic =>
        {
            pic.Name = "CURRENT_PIC";
            pic.FieldName = "CREATED_BY";
            pic.Caption = "Current PIC";

            pic.Width = Unit.Pixel(140);
            pic.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
            pic.CellStyle.HorizontalAlign = HorizontalAlign.Left;
            pic.CellStyle.VerticalAlign = VerticalAlign.Middle;
            pic.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
        });

    setting.Columns.Add(
        prdate =>
        {

            prdate.Caption = "PR Date";
            prdate.Name = "CREATED_DT";
            prdate.FieldName = "CREATED_DT";
            //prdate.ColumnType = MVCxGridViewColumnType.DateEdit;
            //prdate.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
            prdate.ColumnType = MVCxGridViewColumnType.DateEdit;
            prdate.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
            var dateEditProperties = prdate.PropertiesEdit as DateEditProperties;
            dateEditProperties.EditFormat = EditFormat.DateTime;
            dateEditProperties.EditFormatString = "dd.MM.yyyy";
            dateEditProperties.UseMaskBehavior = true;
            prdate.Width = Unit.Pixel(90);
            prdate.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            prdate.Settings.AutoFilterCondition = AutoFilterCondition.Equals;
            
        });
    //-------------------[ PR STATUS END ]----------------------------


    setting.Columns.AddBand(
        columnBand =>
        {
            columnBand.Caption = "Trucking";

            columnBand.Columns.Add(
                codepartner =>
                {
                    codepartner.Name = "LP_CD";
                    codepartner.FieldName = "LP_CD";
                    codepartner.Caption = "Code";
                    codepartner.Width = Unit.Pixel(60);
                    //codepartner.Width = Unit.Percentage(40);
                    codepartner.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    codepartner.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    codepartner.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    codepartner.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                });

            columnBand.Columns.Add(
                lopartner =>
                {
                    lopartner.Name = "LOG_PARTNER_NAME";
                    lopartner.FieldName = "LOG_PARTNER_NAME";
                    lopartner.Caption = "Name";

                    lopartner.Width = Unit.Pixel(250);
                    lopartner.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    lopartner.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                    lopartner.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    lopartner.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                });




        }
        );

    //-------[ RELEASE BY ]--------
    setting.Columns.AddBand(
    columnBand =>
    {
        columnBand.Caption = "Released By";
        columnBand.Columns.Add(
            RSH =>
            {
                RSH.Name = "RSH";
                RSH.FieldName = "SH_APPROVED_BY";
                RSH.Caption = "SH";

                RSH.Width = Unit.Pixel(140);
                RSH.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                RSH.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                RSH.CellStyle.VerticalAlign = VerticalAlign.Middle;
                RSH.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                
                
            });

        columnBand.Columns.Add(
            DPH =>
            {
                DPH.Name = "DPH";
                DPH.FieldName = "DPH_APPROVED_BY";
                DPH.Caption = "DpH";
                DPH.Width = Unit.Pixel(140);
                DPH.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                DPH.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                DPH.CellStyle.VerticalAlign = VerticalAlign.Middle;
                DPH.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            });

        columnBand.Columns.Add(
            DH =>
            {
                DH.Name = "DH";
                DH.FieldName = "DH_APPROVED_BY";
                DH.Caption = "DH";
                DH.Width = Unit.Pixel(140);
                DH.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                DH.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                DH.CellStyle.VerticalAlign = VerticalAlign.Middle;
                DH.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            });


    }
    );

    //-------- TOOGLE-----------------------------------
    setting.Columns.AddBand(
        columnBand =>
        {
            columnBand.Caption = "Released Date";
            columnBand.Name = "RELEASE_DATE";
            columnBand.Visible = false;
            columnBand.Columns.Add(
                RSH =>
                {
                    RSH.Name = "RSH";
                    RSH.FieldName = "SH_RELEASE";
                    RSH.Caption = "SH";
                    //RSH.ColumnType = MVCxGridViewColumnType.DateEdit;
                    //RSH.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                    RSH.ColumnType = MVCxGridViewColumnType.DateEdit;
                    RSH.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                    var dateEditProperties = RSH.PropertiesEdit as DateEditProperties;
                    dateEditProperties.EditFormat = EditFormat.DateTime;
                    dateEditProperties.EditFormatString = "dd.MM.yyyy";
                    dateEditProperties.UseMaskBehavior = true;
                    RSH.Width = Unit.Pixel(130);
                    RSH.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    RSH.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    RSH.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    RSH.Settings.AutoFilterCondition = AutoFilterCondition.Equals;
                });

            columnBand.Columns.Add(
                DPH =>
                {
                    DPH.Name = "DPH";
                    DPH.FieldName = "DPH_RELEASE";
                    DPH.Caption = "DpH";
                    //DPH.ColumnType = MVCxGridViewColumnType.DateEdit;
                    //DPH.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                    DPH.ColumnType = MVCxGridViewColumnType.DateEdit;
                    DPH.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                    var dateEditProperties = DPH.PropertiesEdit as DateEditProperties;
                    dateEditProperties.EditFormat = EditFormat.DateTime;
                    dateEditProperties.EditFormatString = "dd.MM.yyyy";
                    dateEditProperties.UseMaskBehavior = true;
                    DPH.Width = Unit.Pixel(130);
                    DPH.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    DPH.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    DPH.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    DPH.Settings.AutoFilterCondition = AutoFilterCondition.Equals;
                });

            columnBand.Columns.Add(
                DH =>
                {
                    DH.Name = "DH";
                    DH.FieldName = "DH_RELEASE";
                    DH.Caption = "DH";
                    //DH.ColumnType = MVCxGridViewColumnType.DateEdit;
                    //DH.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                    DH.ColumnType = MVCxGridViewColumnType.DateEdit;
                    DH.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                    var dateEditProperties = DH.PropertiesEdit as DateEditProperties;
                    dateEditProperties.EditFormat = EditFormat.DateTime;
                    dateEditProperties.EditFormatString = "dd.MM.yyyy";
                    dateEditProperties.UseMaskBehavior = true;
                    DH.Width = Unit.Pixel(130);
                    DH.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    DH.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    DH.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    DH.Settings.AutoFilterCondition = AutoFilterCondition.Equals;
                });


        }
        );
    setting.Columns.AddBand(
        columnBand =>
        {
            columnBand.Caption = "PR Rejection";
            columnBand.Visible = false;
            columnBand.Name = "PR_REJECTION";
            columnBand.Columns.Add(
                shpr =>
                {
                    shpr.Caption = "By";
                    shpr.Name = "REJECTED_BY";
                    shpr.FieldName = "REJECTED_BY";
                    shpr.Width = Unit.Pixel(140);
                    shpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    shpr.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                    shpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    shpr.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                });
        columnBand.Columns.Add(
            pos =>
            {
                pos.Caption = "Position";
                pos.Name = "REJECTED_POSITION";
                pos.FieldName = "REJECTED_POSITION";
                pos.Width = Unit.Pixel(100);
                pos.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                pos.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                pos.CellStyle.VerticalAlign = VerticalAlign.Middle;
                pos.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                


            });
            
        columnBand.Columns.Add(
            dphpr =>
            {
                dphpr.Caption = "Date";
                dphpr.Name = "REJECTED_DT";
                dphpr.FieldName = "REJECTED_DT";
                
                dphpr.ColumnType = MVCxGridViewColumnType.DateEdit;
                dphpr.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                var dateEditProperties = dphpr.PropertiesEdit as DateEditProperties;
                dateEditProperties.EditFormat = EditFormat.DateTime;
                dateEditProperties.EditFormatString = "dd.MM.yyyy";
                dateEditProperties.UseMaskBehavior = true;
                
                dphpr.Width = Unit.Pixel(130);
                dphpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                dphpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                dphpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                dphpr.Settings.AutoFilterCondition = AutoFilterCondition.Equals;

            });

            

        }
        );
//}).Bind(Model.GetModel<PRApprovalModel>().PRApprovalDatas).GetHtml()
}).Bind(Model.GetModel<List<PRApprovalData>>()).GetHtml()

